# Coveo Badge Component (CoveoBadge)

The Badge component outputs a field value with customizable colors and an icon preceding it.

This component is a result template component (see Result Templates). It extends the FieldValue component. Therefore all FieldValue options are also available for a Badge component.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- getColor
- getValue
- renderOneValue
- get
- parseColors

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- colors

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getColor

- getColor(value?: string): IBadgeColor

- - Defined in ui/Badge/Badge.ts :150

  Gets the icon and text color of a field value.

  #### Parameters

  - ##### Default value value: string = ""

    The field value whose colors to return.

  #### Returns IBadgeColor

  An object with the `icon` and `text` keys.

### getValue

- getValue(): any

- Inherited from FieldValue.getValue

  - Defined in ui/FieldValue/FieldValue.ts :297

  Gets the current FieldValue from the current IQueryResult.

  #### Returns any

  The current FieldValue or `null` if value is and `Object`.

### renderOneValue

- renderOneValue(value: string): HTMLElement

- Overwrites FieldValue.renderOneValue

  - Defined in ui/Badge/Badge.ts :165

  Renders one string value with the appropriate colors and icon.

  #### Parameters

  - ##### value: string

    The field value to render.

  #### Returns HTMLElement

  An HTML `<span>` tag containing the rendered value.

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

### Static parseColors

- parseColors(colorsOption: string): IBadgeColors

- - Defined in ui/Badge/Badge.ts :116

  Parses a Badge.options.colors option string into a workable JSON format.

  #### Parameters

  - ##### colorsOption: string

    The colors option string to parse. See Badge.options.colors.

  #### Returns IBadgeColors

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### colors

colors: IBadgeColors

- Defined in ui/Badge/Badge.ts :73

Specifies the colors for the Badge component.

You must specify the colors in a JSON format similar to what follows:

    {
      "values":{
        "foo":{
          "icon":"blue",
          "text":"#222"
        },
        "bar":{
          "icon":"green",
          "text":"lightgreen"
        }
      },
      "icon":"red",
      "text":"#9ab52b"
    }

This format allows you to customize both the icon and text colors for each field value as well as the default values.

Colors can be specified in HTML or hexadecimal format.

## Constructors

### constructor

- new Badge(element: HTMLElement, options: IBadgeOptions, bindings?: IComponentBindings, result?: IQueryResult): Badge

- Overwrites FieldValue.constructor

  - Defined in ui/Badge/Badge.ts :79

  Creates a new Badge component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IBadgeOptions

    The options for the Badge component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  #### Returns Badge

### Implements

- IComponentBindings